var Runtime = new Object();

Runtime.WorkingModel = function() {
    this.subjectList = [];
    this.subjectToStatements = [];
    this.subjectToTags = [];
    
    this.addStatement = function(subject, predicate, object, objectIsLiteral) {
        var statements = this.subjectToStatements[subject];
        if (!statements) {
            statements = [];
            this.subjectToStatements[subject] = statements;
            this.subjectToTags[subject] = [];
            this.subjectList.push(subject);
        }
        statements.push({ 
            predicate : predicate, 
            object : objectIsLiteral ? ('"' + object + '"') : ('<' + object + '>')
        });
    };

    this.addTag = function(subject, tagLabel) {
        var tags = this.subjectToTags[subject];
        if (!tags) {
            tags = [];
            this.subjectToTags[subject] = tags;
            this.subjectToStatements[subject] = [];
            this.subjectList.unshift(subject);
        }
        tags.push(tagLabel);
    };
}

Runtime.run = function(script, success, failure) {
    var tabBrowser = top.document.getElementById("content");
    var browser = tabBrowser.selectedBrowser;

    var scrapingUtilities = {
        getWorkingModel : function() {
            return new Runtime.WorkingModel();
        }
    };
    var model = scrapingUtilities.getWorkingModel();
    
    var utilities = new PB_ScrapingUtilities();
    utilities.debugPrint = Console.append;
  
    var rehighlight;
    if (Capture.isHighlighting()) {
        Capture.clearAllHighlighting();
        rehighlight = function() { Capture.highlightXPath(true); };
    } else {
        rehighlight = function() {};
    }
    
    try {
        Console.beforeRun();
        Runtime._internalRun(
            browser, 
            model, 
            scrapingUtilities, 
            utilities, 
            script, 
            function() {
                rehighlight();
                Results.setModel(model);
                Console.afterRun();
                success();
            }
        );
    } catch (e) {
        rehighlight();
        Results.setModel(model);
        Console.afterRun();
        failure(e);
    }
}

Runtime._internalRun = function(browser, model, scrapingUtilities, utilities, script, success) {
    var o = { wait: false };
    var doc = browser.contentDocument;
    var wait = function () { o.wait = true; };
    var done = success;
    
    eval(script);
    
    if (!o.wait) {
        success();
    }
}
