var SaveDialog = new Object();

SaveDialog.init = function() {
	var o = window.arguments[0];
  
    document.getElementById("solvent-saveDialog-titleTextbox").value = o.scraperTitle;
    document.getElementById("solvent-saveDialog-uriTextbox").value = o.scraperURI;
    document.getElementById("solvent-saveDialog-descriptionTextbox").value = o.scraperDescription;
    
    document.getElementById("solvent-saveDialog-authorNameTextbox").value = o.authorName;
    
    document.getElementById("solvent-saveDialog-codeFileTextbox").value = o.codeFile;
    document.getElementById("solvent-saveDialog-metadataFileTextbox").value = o.metadataFile;
    
    document.getElementById("solvent-saveDialog-publishCheckbox").checked = o.publish;
    document.getElementById("solvent-saveDialog-publishURLTextbox").value = o.publishURL;
  
    var menulist = document.getElementById("solvent-saveDialog-codeBufferMenuList");
    var menupopup = menulist.firstChild;
    var codeBuffers = o.codeBufferList;
    for (var i = 0; i < codeBuffers.length; i++) {
        var menuitem = document.createElement("menuitem");
        menuitem.setAttribute("label", codeBuffers[i]);
        menupopup.appendChild(menuitem);
    }
    menulist.selectedIndex = o.codeBufferIndex;
    
    if (o.scraperTitle != "") {
        document.getElementById("solvent-saveDialog-tabbox").selectedIndex = 2;
    }
}

SaveDialog.onOK = function() {
    var o = window.arguments[0];
    
    var trim = function(s) {
        return s.replace(/^\s*/, "").replace(/\s*$/, "");
    }
    
    var scraperTitle = trim(document.getElementById("solvent-saveDialog-titleTextbox").value);
    var scraperURI = trim(document.getElementById("solvent-saveDialog-uriTextbox").value);
    var scraperDescription = trim(document.getElementById("solvent-saveDialog-descriptionTextbox").value);
    
    var authorName = trim(document.getElementById("solvent-saveDialog-authorNameTextbox").value);
    
    var codeFilePath = trim(document.getElementById("solvent-saveDialog-codeFileTextbox").value);
    var metadataFilePath = trim(document.getElementById("solvent-saveDialog-metadataFileTextbox").value);
    
    var publish = document.getElementById("solvent-saveDialog-publishCheckbox").checked;
    var publishURL = trim(document.getElementById("solvent-saveDialog-publishURLTextbox").value);
  
    // Check input
    
    if (codeFilePath == "") {
        alert("You must specify where to save the code.");
        return false;
    }
    if (metadataFilePath != "") {
        if (scraperTitle == "") {
            alert("Since you have specified the metadata file, you cannot leave the title of scraper empty.");
            return false;
        }
        if (scraperURI == "") {
            alert("Since you have specified the metadata file, you cannot leave the URI of scraper empty.");
            return false;
        }
        if (publish && publishURL == "") {
            alert("Since you have specified the metadata file and checked the Publish option, you cannot leave the URL of published code empty.");
            return false;
        }
    }
  
    // Save code file
    
    var codeFile = Solvent.getFile(codeFilePath);
    try {
        codeFile.remove(false);
    } catch (e) {
        Solvent.debugPrint("Can't remove file: " + e);
    }

    try {
        var fo = Solvent.openFileToWrite(codeFile);
        
        var code = o.codeBufferRetriever(
            document.getElementById("solvent-saveDialog-codeBufferMenuList").selectedIndex
        );
          
        fo.write(code);
        fo.close();
    } catch (e) {
        Solvent.debugPrint(e);
        alert("Failed to save code file to " + codeFilePath + " due to the following error: " + e);
        return false;
    }
  
    // Save metadata file
    if (metadataFilePath != "") {
    var metadataFile = Solvent.getFile(metadataFilePath);
        try {
          metadataFile.remove(false);
        } catch (e) {
            Solvent.debugPrint("Can't remove file: " + e);
        }

        try {
            var fo = Solvent.openUTF8FileToWrite(metadataFile);
            
            fo.write("@prefix rdf:        <http://www.w3.org/1999/02/22-rdf-syntax-ns#> .\n");
            fo.write("@prefix rdfs:       <http://www.w3.org/2000/01/rdf-schema#> .\n");
            fo.write("@prefix dc:         <http://purl.org/dc/elements/1.1/> .\n");
            fo.write("@prefix pb:         <http://simile.mit.edu/2005/04/piggy-bank#> .\n");
            fo.write("@prefix ss:         <http://simile.mit.edu/2005/08/piggy-bank/scrapers#> .\n");
            fo.write("\n");
            fo.write("<" + scraperURI + ">\n");
            fo.write("  rdf:type pb:JavascriptScreenScraper ;\n");
            fo.write("  rdfs:label \"" + scraperTitle + "\" ;\n");
            
            if (scraperDescription != "") {
                fo.write("  dc:description \"" + scraperDescription + "\" ;\n");
            }
            if (authorName != "") {
                fo.write("  dc:creator \"" + authorName + "\" ;\n");
            }
            
            var urlPatterns = o.urlPatterns;
            for (var i = 0; i < urlPatterns.length; i++) {
                fo.write("  pb:urlPattern \"" + urlPatterns[i].replace(/\\/g, "\\\\") + "\" ;\n");
            }
            
            var url = publish ? publishURL : (new java.io.File(codeFilePath).toURL().toString() + "").replace(/^file\:\//, "file:///");
            fo.write("  pb:javascriptURL \"" + url + "\" .");
            
            fo.close();
        } catch (e) {
            Solvent.debugPrint(e);
            alert("Failed to save metadata file to " + metadataFilePath + " due to the following error: " + e);
            return false;
        }
    }
  
    // Save settings
    
    o.scraperTitle = scraperTitle;
    o.scraperURI = scraperURI;
    o.scraperDescription = scraperDescription;
    
    o.authorName = authorName;
    
    o.codeFile = codeFilePath;
    o.metadataFile = metadataFilePath;
    
    o.publish = publish;
    o.publishURL = publishURL;
    
    // Navigate to metadata file
    if (metadataFilePath != "" && document.getElementById("solvent-saveDialog-showMetadataCheckbox").checked)
    window.opener.openDialog(
        "chrome://browser/content/browser.xul", 
        "_blank", 
        "chrome,all,dialog=no,modal=no", 
        metadataFilePath, 
        null, 
        null
    );
    
    return true;
}

SaveDialog.onCancel = function() {
    return true;
}

SaveDialog.browse = function(textboxID, fileTypeLabel, fileExtensionFilter) {
    var textbox = document.getElementById(textboxID);
    var filepath = textbox.value;
    
    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
    
    fp.init(window, "Save", nsIFilePicker.modeSave);
    try {
        fp.displayDirectory = Solvent.getFile(filepath);
    } catch (e) {
        Solvent.debugPrint("Can't get directory: " + e);
    }
    fp.appendFilter(fileTypeLabel, fileExtensionFilter);
    
    var r = fp.show();
    if (r == nsIFilePicker.returnOK || r == nsIFilePicker.returnReplace) {
        var file = fp.file;
        textbox.value = file.path;
    }
}
