function Token(text, type) {
    this.text = text;
    this.type = type;
}

function splitTokenize(s, matches, type) {
    var tokens = [];
    for (var i = 0; i < matches.length; i++) {
        var match = matches[i];
        var index = s.indexOf(match);
        
        tokens = tokens.concat(tokenize(s.substr(0, index)));
        tokens.push(new Token(match, type));
        
        s = s.substr(index + match.length);
    }
    tokens = tokens.concat(tokenize(s));
    return tokens;
}

function tokenize(s) {
    var i = s.search(/\S/);
    if (i > 0) {
        s = s.substr(i);
    } else if (i < 0) {
        return [];
    }
    
    var floats = s.match(/[-\+]?\d+\.?\d*/);
    if (floats && floats.length > 0) {
        return splitTokenize(s, floats, 2);
    }
    
    var tokens = [];
    while (s.length > 0) {
        var i = s.search(/\W/);
        if (i == 0) {
            tokens.push(new Token(s.substr(0, 1), 0));
            s = s.substr(1);
        } else if (i > 0) {
            tokens.push(new Token(s.substr(0, i), 0));
            s = s.substr(i);
        } else {
            tokens.push(new Token(s, 0));
            break;
        }
        
        i = s.search(/\S/);
        if (i > 0) {
            s = s.substr(i);
        } else if (i < 0) {
            break;
        }
    }
    return tokens;
}
