var URLPatterns = new Object();

URLPatterns.setPatternMatchFlag = function() {
    var r = URLPatterns._testCurrentPatternOnCurrentURL();
    document.getElementById("solvent-scrapeToolbar-urls-match-label").hidden = !r;
    document.getElementById("solvent-scrapeToolbar-urls-notmatch-label").hidden = r;
}

URLPatterns.grabCurrentURL = function() {
    var textbox = URLPatterns._getPatternTextbox();  
    textbox.value = URLPatterns._encode(URLPatterns._getCurrentURL());
    textbox.select();
    textbox.focus();
}

URLPatterns.testOnCurrentURL = function() {
    alert(URLPatterns._testCurrentPatternOnCurrentURL() ? "Match!" : "Not A Match");
}

URLPatterns._testCurrentPatternOnCurrentURL = function() {
    var pattern = URLPatterns._getPatternTextbox().value;
    var url = URLPatterns._getCurrentURL();
    var r = false;
    try {
        r = new java.lang.String(url).matches(pattern);
    } catch (e) {
        Solvent.debugPrint("Can't execute regexp matching: " + e);
    }
    return r;
}

URLPatterns.encode = function() {
    var textbox = URLPatterns._getPatternTextbox();
    var value = textbox.value;
    var prefix = value.substring(0, textbox.selectionStart);
    var selection = value.substring(textbox.selectionStart, textbox.selectionEnd);
    var postfix = value.substring(textbox.selectionEnd);
    
    var selection2 = URLPatterns._encode(selection);
    
    textbox.value = prefix + selection2 + postfix;
    textbox.selectionStart = prefix.length;
    textbox.selectionEnd = prefix.length + selection2.length;
    textbox.focus();
}

URLPatterns.insert = function(text) {
    var textbox = URLPatterns._getPatternTextbox();
    var value = textbox.value;
    var prefix = value.substring(0, textbox.selectionStart);
    var postfix = value.substring(textbox.selectionEnd);
    
    textbox.value = prefix + text + postfix;
    textbox.selectionStart = prefix.length;
    textbox.selectionEnd = prefix.length + text.length;
    textbox.focus();
}

URLPatterns.add = function() {
    var textbox = document.createElement("textbox");
    textbox.setAttribute("oninput", "URLPatterns.setPatternMatchFlag();");
    
    var listitem = document.createElement("listitem");
    listitem.appendChild(textbox);
    
    var listbox = URLPatterns._getPatternsListbox();
    listbox.appendChild(listitem);
    
    listbox.selectedIndex = listbox.getRowCount() - 1;
    textbox.focus();
}

URLPatterns.remove = function() {
    var listbox = URLPatterns._getPatternsListbox();
    if (listbox.getRowCount() > 1) {
        var i = listbox.selectedIndex;
        if (i >= 0) {
            listbox.removeItemAt(i);
            if (i == listbox.getRowCount()) {
                i--;
            }
        
            listbox.selectedIndex = i;
        }
    }
}

URLPatterns._getPatternTextbox = function() {
    var listbox = URLPatterns._getPatternsListbox();
    if (listbox.selectedIndex < 0) {
        listbox.selectedIndex = 0;
    }
    
    var listitem = listbox.selectedItem;
    return listitem.firstChild; // the textbox
}

URLPatterns._getPatternsListbox = function() {
      return document.getElementById("solvent-scrapeToolbar-urls-listbox");
}

URLPatterns._getCurrentURL = function() {
      var tabBrowser = top.document.getElementById("content");
      var browser = tabBrowser.selectedBrowser;
      var doc = browser.contentDocument;
      return doc.location.href;
}

URLPatterns._encode = function(s) {
    return s
        .replace(/\\/g, "\\\\")
        .replace(/\./g, "\\.")
        .replace(/\?/g, "\\?")
        .replace(/\+/g, "\\+")
        .replace(/\&/g, "\\&")
        .replace(/\-/g, "\\-")
        .replace(/\(/g, "\\(")
        .replace(/\)/g, "\\)")
        .replace(/\*/g, "\\*")
        .replace(/\$/g, "\\$")
        .replace(/\^/g, "\\^")
        .replace(/\[/g, "\\[")
        .replace(/\]/g, "\\]");
}
