function printDebug(msg) {
    Components.classes["@mozilla.org/consoleservice;1"]
        .getService(Components.interfaces.nsIConsoleService)
            .logStringMessage(msg);
}

function map(f, a) {
    var b = [];
    if ((typeof a) != "undefined") {
        for (var i = 0; i < a.length; i++) {
            b.push(f(a[i]));
        }
    }
    return b;
}

function mapExceptNull(f, a) {
    var b = [];
    if ((typeof a) != "undefined") {
        for (var i = 0; i < a.length; i++) {
            var o = f(a[i]);
            if (o != null) {
                b.push(o);
            }
        }
    }
    return b;
}

function mapNew(f, a) {
    var b = [];
    if ((typeof a) != "undefined") {
        for (var i = 0; i < a.length; i++) {
            b.push(new f(a[i]));
        }
    }
    return b;
}

function split(a, itemsPerChunk) {
    var b = [];
    var chunk = 0;
    while (chunk < a.length) {
        var item = 0;
        var c = [];
        while (chunk + item < a.length && item < itemsPerChunk) {
            c.push(a[chunk + item]);
            item++;
        }
        b.push(c);
        chunk++;
    }
    return b;
}

function trim(s) {
    if (s.length > 0) {
        s = s.substr(s.search(/\S/));
        if (s.length > 0) {
            s = s.substr(0, s.search(/\s*$/));
        }
    }
    return s;
}

function makeToken(s) {
    var type = 0; // string
    if (/^[-\+]?\d+\.?\d*/.test(s))
        type = 2; // float
    
    return { text: s, type: type };
}

function tokenize(s) {
    var tokens = [];
    while (s.length > 0) {
        var i;
        var numbers = s.match(/^[-\+]?\d+\.?\d*/);
        if ((numbers) && numbers.length > 0) {
            i = numbers[0].length - 1;
            tokens.push({ text: numbers[0], type: 2 });
        } else {
            i = s.search(/\W/);
            if (i == 0) {
                tokens.push(makeToken(s.substr(0, 1)));
            } else if (i > 0) {
                tokens.push(makeToken(s.substr(0, i)));
                tokens.push(makeToken(s.substr(i, 1)));
            } else {
                tokens.push(makeToken(s));
                break;
            }
        }
        s = s.substr(i + 1);
    }
    return tokens;
}

function inspect(o) {
    window.openDialog("chrome://inspector/content/object.xul", "_blank", "chrome,all,dialog=no", o); 
}
